export declare type HttpMethod = "GET" | "HEAD" | "POST" | "PUT" | "PATCH" | "DELETE";
export declare type FunctionLike = (...args: any[]) => unknown;
export declare type RouteMatch = string | RegExp;
export declare type NextHandler = () => ValueOrPromise<any>;
export declare type Nextable<H extends FunctionLike> = (...args: [...Parameters<H>, NextHandler]) => ValueOrPromise<any>;
export declare type FindResult<H extends FunctionLike> = {
    fns: Nextable<H>[];
    params: Record<string, string>;
    middleOnly: boolean;
};
export interface HandlerOptions<Handler extends FunctionLike> {
    onNoMatch?: Handler;
    onError?: (err: unknown, ...args: Parameters<Handler>) => ReturnType<Handler>;
}
export declare type ValueOrPromise<T> = T | Promise<T>;
